"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Request_1 = require("../../enum/Request");
var RequestContext_1 = require("../context/RequestContext");
var XMLHttp = /** @class */ (function () {
    function XMLHttp() {
        this.activeXObjectText = "Microsoft.XMLHTTP";
    }
    /**
     * 初始化 XMLHttpRequest 对象
     * @param url
     * @param method
     * @param body
     * @param timeout
     * @param header
     */
    XMLHttp.prototype.initXMLHttp = function (url, method, body, timeout, header) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (XMLHttpRequest) {
                    this.xhr = new XMLHttpRequest();
                }
                else {
                    this.xhr = new ActiveXObject(this.activeXObjectText);
                }
                if (!this.xhr)
                    throw new Error("XMLHttp initialization failed");
                return [2 /*return*/, new Promise(this.xhrPromise.bind(this, { url: url, method: method, body: body, timeout: timeout, header: header }))];
            });
        });
    };
    /**
     * 异步等待XMLHttpRequest的请求成功回调
     * 相关的生命周期方法也在这里被调用
     * requestContext的一些配置新也在这里面获取
     * @param requestOptions
     * @param resolve
     * @param reject
     */
    XMLHttp.prototype.xhrPromise = function (requestOptions, resolve, reject) {
        var _this = this;
        //获取超时时间
        var timeoutTime = requestOptions.timeout || RequestContext_1.requestContext.getTimeout();
        //部分浏览器不支持timout 待后期使用setTimeout 方法模拟实现
        if (this.xhr.timeout)
            this.xhr.timeout = timeoutTime;
        if (this.xhr.ontimeout)
            this.xhr.ontimeout = RequestContext_1.requestContext.onTimeout;
        //上传进度
        this.xhr.upload.onprogress = RequestContext_1.requestContext.onprogress;
        this.xhr.addEventListener("error", RequestContext_1.requestContext.onError, false);
        //开始请求 beforeRequest 生命周期方法
        RequestContext_1.requestContext.afterRequest && RequestContext_1.requestContext.beforeRequest(requestOptions);
        this.xhr.onreadystatechange = function () { return __awaiter(_this, void 0, void 0, function () {
            var state, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.onReadyStateChange()];
                    case 1:
                        state = _a.sent();
                        if (state) {
                            response = JSON.parse(this.xhr.responseText);
                            //请求成功 调用afterRequest 生命周期方法
                            RequestContext_1.requestContext.afterRequest && RequestContext_1.requestContext.afterRequest(response);
                            resolve(response);
                            return [2 /*return*/];
                        }
                        else {
                            if (this.xhr.readyState === 4) {
                                //请求成功 调用afterRequest 生命周期方法
                                RequestContext_1.requestContext.requestFail && RequestContext_1.requestContext.requestFail(this.xhr);
                                reject();
                            }
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        //判断有没有设置全局的请求参数
        var params = requestOptions.body;
        var globalParams = RequestContext_1.requestContext.getGlobalParams();
        var isFormData = params.append && params.entries && params.delete && params.get;
        if (typeof globalParams === 'object' && globalParams)
            params = Object.assign({}, globalParams, params);
        //设置非GET参数 如果不是GET请求 并且请求的参数是object 将请求参数转换为json字符串
        if (typeof params === 'object' && requestOptions.method.toLocaleUpperCase() !== Request_1.RequestMethod.GET) {
            if (isFormData) {
                //传入 FormData 将全局的参数添加到FormData
                if (globalParams)
                    Object.keys(globalParams).forEach(function (key) { return params.append(key, globalParams[key]); });
            }
            else {
                params = JSON.stringify(params);
            }
        }
        //设置GET参数
        if (requestOptions.method.toLocaleUpperCase() === Request_1.RequestMethod.GET) {
            var urlParams_1 = "";
            var keys_1 = Object.keys(params);
            keys_1.forEach(function (key, index) { return urlParams_1 += key + "=" + params[key] + (index + 1 !== keys_1.length ? '&' : ''); });
            if (requestOptions.url.indexOf("?") === -1)
                requestOptions.url = requestOptions.url + "?";
            requestOptions.url += urlParams_1;
        }
        //判断有没有设置baseURL
        if (RequestContext_1.requestContext.getBaseURL()) {
            requestOptions.url = RequestContext_1.requestContext.getBaseURL() + requestOptions.url;
        }
        //先打开连接
        this.xhr.open(requestOptions.method, requestOptions.url, true);
        //设置请求
        var requestHeaders = RequestContext_1.requestContext.getRequestHeaders() || {};
        var currentHeader = requestOptions.header || {};
        var headers = Object.assign({}, requestHeaders, currentHeader);
        //如果上传的FormData 就不去设置请求头 浏览器会自动识别
        if (headers && !isFormData) {
            var header = Object.keys(headers);
            header.forEach(function (key) { return _this.xhr.setRequestHeader(key, headers[key]); });
        }
        this.xhr.send(params);
    };
    XMLHttp.prototype.onReadyStateChange = function () {
        if (this.xhr.readyState === 4)
            return this.xhr.status === 200;
        return false;
    };
    return XMLHttp;
}());
/**
 * 外部可传入的参数配置
 * 其他的参数待配置
 */
var HttpService = /** @class */ (function (_super) {
    __extends(HttpService, _super);
    function HttpService(requestOptions) {
        var _this = _super.call(this) || this;
        _this.url = requestOptions.url;
        _this.method = requestOptions.method;
        _this.body = requestOptions.body;
        _this.timeout = requestOptions.timeout;
        _this.header = requestOptions.header;
        return _this;
    }
    HttpService.prototype.request = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initXMLHttp(this.url, this.method, this.body, this.timeout, this.header)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return HttpService;
}(XMLHttp));
exports.HttpService = HttpService;
/**
 * 提供给Request装饰器的方法 也可单独使用
 * @param requestParams 装饰器的初使参数
 * @param body 请求题
 */
function request(requestParams, body) {
    return __awaiter(this, void 0, void 0, function () {
        var httpService;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    requestParams.body = Object.assign(requestParams.body, body || {});
                    httpService = new HttpService(requestParams);
                    return [4 /*yield*/, httpService.request()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.request = request;
